Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/HeuristicLab.DataImporter.Command.csproj
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/HeuristicLab.DataImporter.Command.csproj	(revision 8532)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/HeuristicLab.DataImporter.Command.csproj	(revision 8586)
@@ -193,9 +193,9 @@
       <DependentUpon>BoxCoxTransformationCommandView.cs</DependentUpon>
     </Compile>
-    <Compile Include="View\DeleteWithThreshold.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="View\DeleteWithThreshold.Designer.cs">
-      <DependentUpon>DeleteWithThreshold.cs</DependentUpon>
+    <Compile Include="View\DeleteWithThresholdView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="View\DeleteWithThresholdView.Designer.cs">
+      <DependentUpon>DeleteWithThresholdView.cs</DependentUpon>
     </Compile>
     <Compile Include="View\FilterSavitzkyGolayCommandView.cs">
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteColumnsWithMissingValuesThresholdCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteColumnsWithMissingValuesThresholdCommand.cs	(revision 8532)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteColumnsWithMissingValuesThresholdCommand.cs	(revision 8586)
@@ -29,5 +29,5 @@
   [StorableClass]
   [ViewableCommandInfoAttribute("Delete Columns beneath Threshold", 1, ColumnGroupState.AnySelectedColumnContainsNull,
-    "Handle Missing Values", Position = 6, OptionsView = typeof(DeleteWithThreshold))]
+    "Handle Missing Values", Position = 6, OptionsView = typeof(DeleteWithThresholdView))]
   public class DeleteColumnsWithMissingValuesThresholdCommand : ColumnGroupCommandWithAffectedColumnsBase, IThresholdCommand {
     private ColumnBase oldColumn;
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteRowsWithMissingValuesThresholdCommand.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteRowsWithMissingValuesThresholdCommand.cs	(revision 8532)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/MissingValues/DeleteRowsWithMissingValuesThresholdCommand.cs	(revision 8586)
@@ -32,5 +32,5 @@
   [StorableClass]
   [ViewableCommandInfoAttribute("Delete Rows beneath Threshold", 1, ColumnGroupState.Active,
-    "Handle Missing Values", Position = 5, OptionsView = typeof(DeleteWithThreshold))]
+    "Handle Missing Values", Position = 5, OptionsView = typeof(DeleteWithThresholdView))]
   public class DeleteRowsWithMissingValuesThresholdCommand : ColumnGroupCommandBase, IThresholdCommand {
     private Dictionary<int, IComparable[]> deletedRows;
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThreshold.Designer.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThreshold.Designer.cs	(revision 8532)
+++ 	(revision )
@@ -1,67 +1,0 @@
-﻿namespace HeuristicLab.DataImporter.Command.View {
-  partial class DeleteWithThreshold {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.txtThreshold = new System.Windows.Forms.TextBox();
-      this.lblThreshold = new System.Windows.Forms.Label();
-      this.SuspendLayout();
-      // 
-      // txtThreshold
-      // 
-      this.txtThreshold.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.txtThreshold.Location = new System.Drawing.Point(66, 3);
-      this.txtThreshold.Name = "txtThreshold";
-      this.txtThreshold.Size = new System.Drawing.Size(100, 20);
-      this.txtThreshold.TabIndex = 0;
-      this.txtThreshold.Validating += new System.ComponentModel.CancelEventHandler(this.txtThreshold_Validating);
-      // 
-      // lblThreshold
-      // 
-      this.lblThreshold.AutoSize = true;
-      this.lblThreshold.Location = new System.Drawing.Point(3, 6);
-      this.lblThreshold.Name = "lblThreshold";
-      this.lblThreshold.Size = new System.Drawing.Size(57, 13);
-      this.lblThreshold.TabIndex = 1;
-      this.lblThreshold.Text = "Threshold:";
-      // 
-      // DeleteWithThreshold
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.lblThreshold);
-      this.Controls.Add(this.txtThreshold);
-      this.Name = "DeleteWithThreshold";
-      this.Size = new System.Drawing.Size(173, 28);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.TextBox txtThreshold;
-    private System.Windows.Forms.Label lblThreshold;
-  }
-}
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThreshold.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThreshold.cs	(revision 8532)
+++ 	(revision )
@@ -1,65 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Windows.Forms;
-using HeuristicLab.DataImporter.Data.CommandBase;
-namespace HeuristicLab.DataImporter.Command.View {
-  public partial class DeleteWithThreshold : HeuristicLab.DataImporter.Data.CommandBase.CommandViewBase {
-    public DeleteWithThreshold() {
-      InitializeComponent();
-    }
-
-    public DeleteWithThreshold(IThresholdCommand command)
-      : this() {
-      if (command != null) {
-        threshold = command.Threshold;
-        txtThreshold.Text = command.Threshold.ToString();
-      }
-      this.Command = command;
-    }
-
-    public new IThresholdCommand Command {
-      get { return (IThresholdCommand)base.Command; }
-      set { base.Command = value; this.UpdateCommand(); }
-    }
-
-    private double threshold;
-    public double Threshold { get { return Command.Threshold; } }
-
-    private void txtThreshold_Validating(object sender, System.ComponentModel.CancelEventArgs e) {
-      TextBox textBox = (TextBox)sender;
-      e.Cancel = !Double.TryParse(textBox.Text, out threshold);
-      e.Cancel = e.Cancel || threshold < 0.0 || threshold > 1.0;
-      if (e.Cancel) {
-        MessageBox.Show("Threshold has to be between 0.0 and 1.0");
-      } else {
-        UpdateCommand();
-      }
-    }
-
-    private void UpdateCommand() {
-      if (this.Command != null) {
-        Command.Threshold = this.threshold;
-      }
-    }
-  }
-}
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.Designer.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.Designer.cs	(revision 8586)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.Designer.cs	(revision 8586)
@@ -0,0 +1,67 @@
+﻿namespace HeuristicLab.DataImporter.Command.View {
+  partial class DeleteWithThresholdView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.txtThreshold = new System.Windows.Forms.TextBox();
+      this.lblThreshold = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // txtThreshold
+      // 
+      this.txtThreshold.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.txtThreshold.Location = new System.Drawing.Point(66, 3);
+      this.txtThreshold.Name = "txtThreshold";
+      this.txtThreshold.Size = new System.Drawing.Size(100, 20);
+      this.txtThreshold.TabIndex = 0;
+      this.txtThreshold.Validating += new System.ComponentModel.CancelEventHandler(this.txtThreshold_Validating);
+      // 
+      // lblThreshold
+      // 
+      this.lblThreshold.AutoSize = true;
+      this.lblThreshold.Location = new System.Drawing.Point(3, 6);
+      this.lblThreshold.Name = "lblThreshold";
+      this.lblThreshold.Size = new System.Drawing.Size(57, 13);
+      this.lblThreshold.TabIndex = 1;
+      this.lblThreshold.Text = "Threshold:";
+      // 
+      // DeleteWithThreshold
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.lblThreshold);
+      this.Controls.Add(this.txtThreshold);
+      this.Name = "DeleteWithThreshold";
+      this.Size = new System.Drawing.Size(173, 28);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.TextBox txtThreshold;
+    private System.Windows.Forms.Label lblThreshold;
+  }
+}
Index: branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.cs
===================================================================
--- branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.cs	(revision 8586)
+++ branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.Command/View/DeleteWithThresholdView.cs	(revision 8586)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.DataImporter.Data.CommandBase;
+
+namespace HeuristicLab.DataImporter.Command.View {
+  public partial class DeleteWithThresholdView : CommandViewBase {
+    public DeleteWithThresholdView() {
+      InitializeComponent();
+    }
+
+    public DeleteWithThresholdView(IThresholdCommand command)
+      : this() {
+      if (command != null) {
+        threshold = command.Threshold;
+        txtThreshold.Text = command.Threshold.ToString();
+      }
+      this.Command = command;
+    }
+
+    public new IThresholdCommand Command {
+      get { return (IThresholdCommand)base.Command; }
+      set { base.Command = value; this.UpdateCommand(); }
+    }
+
+    private double threshold;
+
+    private void txtThreshold_Validating(object sender, System.ComponentModel.CancelEventArgs e) {
+      TextBox textBox = (TextBox)sender;
+      e.Cancel = !Double.TryParse(textBox.Text, out threshold);
+      e.Cancel = e.Cancel || threshold < 0.0 || threshold > 1.0;
+      if (e.Cancel) {
+        MessageBox.Show("Threshold has to be between 0.0 and 1.0");
+      } else {
+        UpdateCommand();
+      }
+    }
+
+    private void UpdateCommand() {
+      if (this.Command != null) {
+        Command.Threshold = this.threshold;
+      }
+    }
+  }
+}